/*;---------------------------------------------------------------------------------
;					Patcher (based on Folko's Injector)
;	by 0xD aka XaocDark (XD), e-mail: xaocdark@mail.ru, icq: 259199942
;				special for UOSoft project (http://uosoft.ru)
;---------------------------------------------------------------------------------*/

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <string.h>
#include "patchres.h"

static BOOL CALLBACK DialogFunc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam);

#ifndef PE_H_INCLUDED
#define PE_H_INCLUDED

#define CalcDist(from, to) ((to)-(from)-5)

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#endif

void PutD(unsigned char *Buffer, unsigned long val)
{
   *(Buffer+0)=(unsigned char)(val>>0);
   *(Buffer+1)=(unsigned char)(val>>8);
   *(Buffer+2)=(unsigned char)(val>>16);
   *(Buffer+3)=(unsigned char)(val>>24);
}


/* based on Luevelsmeyer's 'dump_import_directory()' */
long GetFunc(char *DllName, char *FuncName, void *section_base, DWORD section_rva, IMAGE_IMPORT_DESCRIPTOR *imp)
{
    #define adr(rva) ((const void*)((char*)section_base+((DWORD)(rva))-section_rva))
    while(!IsBadReadPtr(imp, sizeof(*imp)) && imp->Name)
      {
          const IMAGE_THUNK_DATA *import_entry;
          if(strcmp((char*)adr(imp->Name), DllName)==0)
          {
            long thunk=(long)imp->FirstThunk;
            import_entry = (IMAGE_THUNK_DATA*)(adr(imp->OriginalFirstThunk));
            while(import_entry->u1.Ordinal)
            {
               const IMAGE_IMPORT_BY_NAME *name_import =(IMAGE_IMPORT_BY_NAME*)( adr(import_entry->u1.AddressOfData));
               if(strcmp((char*)name_import->Name, FuncName)==0)
                  return thunk;
               import_entry++;
               thunk+=sizeof(IMAGE_THUNK_DATA);
            }
          }
          imp++;
      }
    #undef adr
    return 0;
}

unsigned long FileSize(FILE *File)
{
	unsigned long size, old;
   	old=ftell(File);
	fseek(File, 0, SEEK_END);
	size=ftell(File);
	fseek(File, old, SEEK_SET);
	return size;
}

int APIENTRY WinMain(HINSTANCE hinst, HINSTANCE hinstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASS wc;
	INITCOMMONCONTROLSEX cc;

	memset(&wc,0,sizeof(wc));
	wc.lpfnWndProc = DefDlgProc;
	wc.cbWndExtra = DLGWINDOWEXTRA;
	wc.hInstance = hinst;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
	wc.lpszClassName = "Patcher by 0xD aka XaocDark";
	RegisterClass(&wc);
	memset(&cc,0,sizeof(cc));
	cc.dwSize = sizeof(cc);
	cc.dwICC = 0xffffffff;
	InitCommonControlsEx(&cc);

	return DialogBox(hinst, MAKEINTRESOURCE(IDD_MAINDIALOG), NULL, (DLGPROC) DialogFunc);

}

static int InitializeApp(HWND hDlg,WPARAM wParam, LPARAM lParam)
{
	return 1;
}

static int InitializeCombobox(HWND hCombo)
{
	HANDLE hSearch;
	WIN32_FIND_DATA wfd;
	hSearch=FindFirstFile("*.dll",&wfd);
	if (hSearch==INVALID_HANDLE_VALUE || hSearch==NULL) {
		FindClose(hSearch);
		return 0;
	}

	for (;;)
	{
		if (wfd.cFileName!="." && wfd.dwFileAttributes!=FILE_ATTRIBUTE_DIRECTORY)
			SendMessage(hCombo,CB_ADDSTRING,0,(int)&wfd.cFileName);
		if (FindNextFile(hSearch,&wfd)==0)
			break;
	}
	FindClose(hSearch);
	SendMessage(hCombo,CB_SETCURSEL,0,0);
	SetFocus(hCombo);
	return 1;
}

int Patch(char *DLL)
{
   	FILE *Target=0, *Patched=0;
	unsigned long pointer=0;
	unsigned long imagesize, ImageBase, import_rva, iat_rva, import_length;
	unsigned char *FileBuffer, *newsect, *sectiondata[255];
	void *import_address, *iat_address;
   	long OEP, NEP, lola, getpa;
   	long imports=0, iat=0;
   	int mysect, mysectsize, i;
	PIMAGE_DOS_HEADER doshdr;
	PIMAGE_FILE_HEADER filehdr;
	PIMAGE_OPTIONAL_HEADER opthdr;
	PIMAGE_SECTION_HEADER secthdrs[255];

	Target=fopen("client.exe", "rb");
	if(!Target)
	{
		MessageBox(0,"Client.exe not found!","Error",MB_OK);
		return 0;
	}
	imagesize=FileSize(Target);
   	FileBuffer=malloc(imagesize);
	fread(FileBuffer, sizeof(unsigned char), imagesize, Target);
	fclose(Target);
   	if(*(WORD*)FileBuffer!=IMAGE_DOS_SIGNATURE) {
      	free(FileBuffer);
		MessageBox(0,"Client.exe isn't a valid PE (exe) file!","Error",MB_OK);
      	return 0;
  	}
	doshdr=(IMAGE_DOS_HEADER*)FileBuffer; pointer=doshdr->e_lfanew;
	if(*(DWORD*)(FileBuffer+pointer)!=IMAGE_NT_SIGNATURE) {
		free(FileBuffer);
      	MessageBox(0,"Client.exe isn't a valid PE (exe) file!","Error",MB_OK);
      	return 0;
   	}
   	pointer+=sizeof(IMAGE_NT_SIGNATURE);
   	filehdr=(IMAGE_FILE_HEADER*)(FileBuffer+pointer);
	pointer+=sizeof(IMAGE_FILE_HEADER);
	opthdr=(IMAGE_OPTIONAL_HEADER*)(FileBuffer+pointer);
	pointer+=sizeof(IMAGE_OPTIONAL_HEADER);
   	ImageBase=opthdr->ImageBase;
   	import_rva=opthdr->DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress;
   	iat_rva=opthdr->DataDirectory[IMAGE_DIRECTORY_ENTRY_IAT].VirtualAddress;
   	for(i=0; i<filehdr->NumberOfSections; i++) {
		unsigned long sectstart, sectend;
      	secthdrs[i]=(IMAGE_SECTION_HEADER*)(FileBuffer+pointer);
		secthdrs[i]->Characteristics|=IMAGE_SCN_MEM_WRITE;
		secthdrs[i]->Characteristics|=IMAGE_SCN_MEM_READ;

      	if(secthdrs[i]->VirtualAddress<=import_rva && import_rva<secthdrs[i]->VirtualAddress+secthdrs[i]->SizeOfRawData)
         	imports=i;
      	if(secthdrs[i]->VirtualAddress<=iat_rva && iat_rva<secthdrs[i]->VirtualAddress+secthdrs[i]->SizeOfRawData)
         	iat=i;
		pointer+=sizeof(IMAGE_SECTION_HEADER);
	}
	mysect=filehdr->NumberOfSections;
	mysectsize=opthdr->SectionAlignment;
	opthdr->SizeOfImage+=mysectsize;
	filehdr->NumberOfSections++;
	if(FileBuffer[pointer]!=0 || FileBuffer[pointer+sizeof(IMAGE_SECTION_HEADER)]!=0) {
      	MessageBox(0,"No free space to add a new section! File appears to be packed.","Error",MB_OK);
		free(FileBuffer);
		return 0;
	}
	secthdrs[mysect]=(IMAGE_SECTION_HEADER*)(FileBuffer+pointer);
	secthdrs[mysect]->Characteristics=IMAGE_SCN_MEM_READ | IMAGE_SCN_MEM_WRITE | IMAGE_SCN_MEM_EXECUTE | IMAGE_SCN_CNT_CODE;
	strcpy((char*)secthdrs[mysect]->Name, "Patcher");
	secthdrs[mysect]->PointerToRawData=0;
	secthdrs[mysect]->SizeOfRawData=mysectsize;
	secthdrs[mysect]->Misc.VirtualSize=mysectsize;
	while(++pointer%opthdr->FileAlignment);
	for(i=0; i<filehdr->NumberOfSections-1; i++) {
		sectiondata[i]=(unsigned char*)(FileBuffer+pointer);
		pointer+=secthdrs[i]->SizeOfRawData;
	}
	OEP=opthdr->AddressOfEntryPoint;
	secthdrs[mysect]->PointerToRawData=pointer;
	secthdrs[mysect]->VirtualAddress=secthdrs[mysect-1]->VirtualAddress+secthdrs[mysect-1]->Misc.VirtualSize;
	if(secthdrs[mysect]->VirtualAddress%opthdr->SectionAlignment!=0)
		while(++secthdrs[mysect]->VirtualAddress%opthdr->SectionAlignment);
   	import_address=FileBuffer+secthdrs[imports]->PointerToRawData;
   	lola=GetFunc("KERNEL32.dll", "LoadLibraryA", import_address, secthdrs[imports]->VirtualAddress,
      (IMAGE_IMPORT_DESCRIPTOR*)((char*)import_address+import_rva-secthdrs[imports]->VirtualAddress)
      );
   	getpa=GetFunc("KERNEL32.dll", "GetProcAddress", import_address, secthdrs[imports]->VirtualAddress,
      (IMAGE_IMPORT_DESCRIPTOR*)((char*)import_address+import_rva-secthdrs[imports]->VirtualAddress)
      );
   	if(!lola || !getpa)
   	{
		MessageBox(0,"Program seems to be crypted / packed; can't find LoadLibraryA and GetProcAddress!","Error",MB_OK);
		return 0;
	}
	NEP=opthdr->AddressOfEntryPoint=secthdrs[mysect]->VirtualAddress;
	newsect=malloc(mysectsize);
	memset(newsect, 0x90, mysectsize);
   	{
      	char *DllName=DLL;
      	char *FuncName="Init";
      	int DllLen=(int)strlen(DllName)+1;
      	int FuncLen=(int)strlen(FuncName)+1;
      	unsigned char stub[]=
      	{
         0x68, 0x00, 0x00, 0x00, 0x00,
         0xFF, 0x15, 0x00, 0x00, 0x00, 0x00,
         0x68, 0x00, 0x00, 0x00, 0x00,
         0x50,
         0xFF, 0x15, 0x00, 0x00, 0x00, 0x00,
         0xFF, 0xD0,
         0xE9, 0x00, 0x00, 0x00, 0x00
		};

      	PutD(stub+1, NEP+ImageBase+sizeof(stub)+1);
      	PutD(stub+7,ImageBase+lola);
      	PutD(stub+12,NEP+ImageBase+sizeof(stub)+DllLen+1);
      	PutD(stub+19,ImageBase+getpa);
      	PutD(stub+26, CalcDist(NEP+25, OEP));
      	memcpy(newsect, stub, sizeof(stub));
      	memcpy(newsect+sizeof(stub)+1, DllName, DllLen);
      	memcpy(newsect+sizeof(stub)+DllLen+1, FuncName, FuncLen);
  	}
   	{
      	char FileName[MAX_PATH];
      	char *FilePtr=0;
      	GetFullPathName("Client.exe", sizeof(FileName), FileName, &FilePtr);

      	FileName[((strrchr(FileName, '\\')+1)-FileName)]=0;
      	strcat(FileName, "PClient.exe");
      	Patched=fopen(FileName, "wb");
	   	fwrite(FileBuffer, sizeof(unsigned char), pointer, Patched);
	   	fwrite(newsect, sizeof(unsigned char), mysectsize, Patched);
	   	fclose(Patched);
   	}
	free(newsect);
	free(FileBuffer);
	MessageBox(0,"File successfuly patched!","Patcher.exe",MB_OK);
	return 0;
}

static BOOL CALLBACK DialogFunc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HWND hCombo;
	char text[128];
	switch (msg) {

	case WM_INITDIALOG:
		InitializeApp(hwndDlg,wParam,lParam);
		InitializeCombobox(GetDlgItem(hwndDlg,4));
		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
			case IDPATCH1:
				GetDlgItemText(hwndDlg,4,text,128);
				Patch(text);
				return 1;
			case IDHELP1:
				MessageBox(0,"\t         Patcher (based on Folko's Injector)\nby 0xD aka XaocDark (XD), e-mail: xaocdark@mail.ru, icq: 259199942\n\t    special for UOSoft project (http://uosoft.ru)","About",MB_OK);
				return 1;
			case IDCLOSE1:
				EndDialog(hwndDlg,0);
				return 1;
		}
		break;

	case WM_CLOSE:
		EndDialog(hwndDlg,0);
		return TRUE;

	}
	return FALSE;
}
